{
    "$graph": [
        {
            "class": "CommandLineTool",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "biowardrobe2/sratoolkit:v2.8.2-1"
                },
                {
                    "class": "SoftwareRequirement",
                    "packages": [
                        {
                            "specs": [
                                "http://identifiers.org/biotools/sra-tools"
                            ],
                            "version": [
                                "2.8.2"
                            ],
                            "package": "sra-tools"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 11,
                        "prefix": "--aligned"
                    },
                    "doc": "Dump only aligned sequences\n",
                    "id": "#fastq_dump.cwl/aligned"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 13,
                        "prefix": "--aligned-region"
                    },
                    "doc": "Filter by position on genome.\nName can either be accession.version\n(ex:NC_000001.10) or file specific name\n(ex:\"chr1\" or \"1\"). \"from\" and \"to\" are 1-based coordinates\n",
                    "id": "#fastq_dump.cwl/aligned_region"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 6,
                        "prefix": "--clip"
                    },
                    "doc": "Clip adapter sequences\n",
                    "id": "#fastq_dump.cwl/clip"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 34,
                        "prefix": "--defline-qual"
                    },
                    "doc": "Defline format specification for quality.\n<fmt> is string of characters and/or\nvariables. The variables can be one of: $ac\n- accession, $si spot id, $sn spot\nname, $sg spot group (barcode), $sl spot\nlength in bases, $ri read number, $rn\nread name, $rl read length in bases. '[]'\ncould be used for an optional output: if\nall vars in [] yield empty values whole\ngroup is not printed. Empty value is empty\nstring or for numeric variables. Ex:\n@$sn[_$rn]/$ri '_$rn' is omitted if name\nis empty\n",
                    "id": "#fastq_dump.cwl/defline_qual"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 33,
                        "prefix": "--defline-seq"
                    },
                    "doc": "Defline format specification for sequence.\n",
                    "id": "#fastq_dump.cwl/defline_seq"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 35,
                        "prefix": "--disable-multithreading"
                    },
                    "doc": "disable multithreading\n",
                    "id": "#fastq_dump.cwl/disable_multithreading"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 26,
                        "prefix": "--dumpbase"
                    },
                    "doc": "Formats sequence using base space (default\nfor other than SOLiD).\n",
                    "id": "#fastq_dump.cwl/dumpbase"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 25,
                        "prefix": "--dumpcs"
                    },
                    "doc": "Formats sequence using color space (default\nfor SOLiD),\"cskey\" may be specified for\ntranslation\n",
                    "id": "#fastq_dump.cwl/dumpcs"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 28,
                        "prefix": "--fasta"
                    },
                    "doc": "FASTA only, no qualities, optional line\nwrap width (set to zero for no wrapping)\n",
                    "id": "#fastq_dump.cwl/fasta"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 32,
                        "prefix": "--helicos"
                    },
                    "doc": "Helicos style defline\n",
                    "id": "#fastq_dump.cwl/helicos"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "name": "#fastq_dump.cwl/matepair_distance/distance",
                            "symbols": [
                                "#fastq_dump.cwl/matepair_distance/distance/from-to",
                                "#fastq_dump.cwl/matepair_distance/distance/unknown"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "position": 14,
                        "prefix": "--matepair-distance"
                    },
                    "doc": "Filter by distance beiween matepairs.\nUse \"unknown\" to find matepairs split\nbetween the references. Use from-to to limit\nmatepair distance on the same reference\n",
                    "id": "#fastq_dump.cwl/matepair_distance"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "--maxSpotId"
                    },
                    "doc": "Maximum spot id\n",
                    "id": "#fastq_dump.cwl/max_spot_id"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 7,
                        "prefix": "--minReadLen"
                    },
                    "doc": "Filter by sequence length >= <len>\n",
                    "id": "#fastq_dump.cwl/min_read_len"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--minSpotId"
                    },
                    "doc": "Minimum spot id\n",
                    "id": "#fastq_dump.cwl/min_spot_id"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 27,
                        "prefix": "--offset"
                    },
                    "doc": "Offset to use for quality conversion, default is 33\n",
                    "id": "#fastq_dump.cwl/offset"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 30,
                        "prefix": "--origfmt"
                    },
                    "doc": "Defline contains only original sequence name\n",
                    "id": "#fastq_dump.cwl/origfmt"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 9,
                        "prefix": "--qual-filter"
                    },
                    "doc": "Filter used in early 1000 Genomes data: no sequences starting or ending with >= 10N\n",
                    "id": "#fastq_dump.cwl/qual_filter"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 10,
                        "prefix": "--qual-filter-1"
                    },
                    "doc": "Filter used in current 1000 Genomes data\n",
                    "id": "#fastq_dump.cwl/qual_filter_1"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 31,
                        "prefix": "--readids"
                    },
                    "doc": "Append read id after spot id as 'accession.spot.readid' on defline\n",
                    "id": "#fastq_dump.cwl/readids"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 15,
                        "prefix": "--skip-technical"
                    },
                    "doc": "Dump only biological reads\n",
                    "id": "#fastq_dump.cwl/skip_technical"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 21,
                        "prefix": "--split-3"
                    },
                    "doc": "Legacy 3-file splitting for mate-pairs:\nFirst biological reads satisfying dumping\nconditions are placed in files *_1.fastq and\n*_2.fastq If only one biological read is\npresent it is placed in *.fastq Biological\nreads and above are ignored.\n",
                    "id": "#fastq_dump.cwl/split_3"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 20,
                        "prefix": "--split-files"
                    },
                    "doc": "Dump each read into separate file.\nFiles will receive suffix corresponding to read number\n",
                    "id": "#fastq_dump.cwl/split_files"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--split-spot"
                    },
                    "doc": "Split spots into individual reads\n",
                    "id": "#fastq_dump.cwl/split_spot"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 60
                    },
                    "doc": "Input file\n",
                    "id": "#fastq_dump.cwl/sra_file"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 29,
                        "prefix": "--suppress-qual-for-cskey"
                    },
                    "doc": "supress quality-value for cskey\n",
                    "id": "#fastq_dump.cwl/suppress_qual_for_cskey"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 12,
                        "prefix": "--unaligned"
                    },
                    "doc": "Dump only unaligned sequences\n",
                    "id": "#fastq_dump.cwl/unaligned"
                }
            ],
            "baseCommand": [
                "fastq-dump"
            ],
            "doc": "Tool runs fastq-dump from NCBI SRA toolkit\nSupports only file inputs.\nOutput file names are formed on the base of `sra_file` input basename.\n",
            "id": "#fastq_dump.cwl",
            "http://schema.org/name": "fastq_dump",
            "http://schema.org/license": "http://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/isPartOf": {
                "class": "http://schema.org/CreativeWork",
                "http://schema.org/name": "Common Workflow Language",
                "http://schema.org/url": "http://commonwl.org/"
            },
            "http://schema.org/creator": [
                {
                    "class": "http://schema.org/Organization",
                    "http://schema.org/legalName": "Cincinnati Children's Hospital Medical Center",
                    "http://schema.org/location": [
                        {
                            "class": "http://schema.org/PostalAddress",
                            "http://schema.org/addressCountry": "USA",
                            "http://schema.org/addressLocality": "Cincinnati",
                            "http://schema.org/addressRegion": "OH",
                            "http://schema.org/postalCode": "45229",
                            "http://schema.org/streetAddress": "3333 Burnet Ave",
                            "http://schema.org/telephone": "+1(513)636-4200"
                        }
                    ],
                    "http://schema.org/logo": "https://www.cincinnatichildrens.org/-/media/cincinnati%20childrens/global%20shared/childrens-logo-new.png",
                    "http://schema.org/department": [
                        {
                            "class": "http://schema.org/Organization",
                            "http://schema.org/legalName": "Allergy and Immunology",
                            "http://schema.org/department": [
                                {
                                    "class": "http://schema.org/Organization",
                                    "http://schema.org/legalName": "Barski Research Lab",
                                    "http://schema.org/member": [
                                        {
                                            "class": "http://schema.org/Person",
                                            "http://schema.org/name": "Michael Kotliar",
                                            "http://schema.org/email": "mailto:misha.kotliar@gmail.com",
                                            "http://schema.org/sameAs": [
                                                {
                                                    "id": "#0000-0002-6486-3898"
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "format": "https://edamontology.org/format_1931",
                    "outputBinding": {
                        "glob": "$(inputs.sra_file.nameroot)*.fastq"
                    },
                    "id": "#fastq_dump.cwl/all_fastq_files"
                },
                {
                    "type": "File",
                    "format": "https://edamontology.org/format_1931",
                    "outputBinding": {
                        "glob": [
                            "$(inputs.sra_file.nameroot).fastq",
                            "$(inputs.sra_file.nameroot)_1.fastq"
                        ]
                    },
                    "id": "#fastq_dump.cwl/fastq_file_1"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "format": "https://edamontology.org/format_1931",
                    "outputBinding": {
                        "glob": "$(inputs.sra_file.nameroot)_2.fastq"
                    },
                    "id": "#fastq_dump.cwl/fastq_file_2"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "hints": [
                {
                    "dockerPull": "quay.io/biocontainers/sra-tools:2.10.3--pl526haddd2b5_0",
                    "class": "DockerRequirement"
                },
                {
                    "packages": [
                        {
                            "specs": [
                                "http://identifiers.org/biotools/sra-tools"
                            ],
                            "version": [
                                "2.10.3"
                            ],
                            "package": "sra-tools"
                        }
                    ],
                    "class": "SoftwareRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 4
                    },
                    "doc": "SRA read accession\n",
                    "id": "#prefetch.cwl/accession"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-t"
                    },
                    "doc": "Transport protocol to use 'fasp', 'http' or 'both'\n",
                    "id": "#prefetch.cwl/transport"
                }
            ],
            "arguments": [
                "-O",
                "."
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.accession)/$(inputs.accession).sra"
                    },
                    "id": "#prefetch.cwl/sra_file"
                }
            ],
            "baseCommand": [
                "prefetch"
            ],
            "doc": "Tool runs prefetch from NCBI SRA toolkit\n",
            "id": "#prefetch.cwl",
            "http://schema.org/name": "prefetch",
            "http://schema.org/license": "http://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/isPartOf": {
                "class": "http://schema.org/CreativeWork",
                "http://schema.org/name": "Common Workflow Language",
                "http://schema.org/url": "http://commonwl.org/"
            },
            "http://schema.org/creator": [
                {
                    "class": "http://schema.org/Organization",
                    "http://schema.org/legalName": "Cincinnati Children's Hospital Medical Center",
                    "http://schema.org/location": [
                        {
                            "class": "http://schema.org/PostalAddress",
                            "http://schema.org/addressCountry": "USA",
                            "http://schema.org/addressLocality": "Cincinnati",
                            "http://schema.org/addressRegion": "OH",
                            "http://schema.org/postalCode": "45229",
                            "http://schema.org/streetAddress": "3333 Burnet Ave",
                            "http://schema.org/telephone": "+1(513)636-4200"
                        }
                    ],
                    "http://schema.org/logo": "https://www.cincinnatichildrens.org/-/media/cincinnati%20childrens/global%20shared/childrens-logo-new.png",
                    "http://schema.org/department": [
                        {
                            "class": "http://schema.org/Organization",
                            "http://schema.org/legalName": "Allergy and Immunology",
                            "http://schema.org/department": [
                                {
                                    "class": "http://schema.org/Organization",
                                    "http://schema.org/legalName": "Barski Research Lab",
                                    "http://schema.org/member": [
                                        {
                                            "class": "http://schema.org/Person",
                                            "http://schema.org/name": "Michael Kotliar",
                                            "http://schema.org/email": "mailto:misha.kotliar@gmail.com",
                                            "http://schema.org/sameAs": [
                                                {
                                                    "$import": "#0000-0002-6486-3898"
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ]
        },
        {
            "class": "Workflow",
            "doc": "Worfklow combining an SRA fetch from NCBI with a fastq-dump cmd\n",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#main/sra_accession"
                }
            ],
            "steps": [
                {
                    "in": [
                        {
                            "default": true,
                            "id": "#main/fastq_dump/split_files"
                        },
                        {
                            "source": "#main/prefetch/sra_file",
                            "id": "#main/fastq_dump/sra_file"
                        }
                    ],
                    "out": [
                        "#main/fastq_dump/all_fastq_files",
                        "#main/fastq_dump/fastq_file_1",
                        "#main/fastq_dump/fastq_file_2"
                    ],
                    "run": "#fastq_dump.cwl",
                    "id": "#main/fastq_dump"
                },
                {
                    "in": [
                        {
                            "source": "#main/sra_accession",
                            "id": "#main/prefetch/accession"
                        }
                    ],
                    "out": [
                        "#main/prefetch/sra_file"
                    ],
                    "run": "#prefetch.cwl",
                    "id": "#main/prefetch"
                },
                {
                    "in": [
                        {
                            "source": "#main/sra_accession",
                            "id": "#main/rename_fastq1/accession"
                        },
                        {
                            "source": "#main/fastq_dump/fastq_file_2",
                            "id": "#main/rename_fastq1/fastq2"
                        },
                        {
                            "valueFrom": "${\n  if (inputs.fastq2) {\n    return inputs.srcfile.basename;\n  } else {\n    return inputs.accession + '.fastq';\n  }\n}\n",
                            "id": "#main/rename_fastq1/newname"
                        },
                        {
                            "source": "#main/fastq_dump/fastq_file_1",
                            "id": "#main/rename_fastq1/srcfile"
                        }
                    ],
                    "out": [
                        "#main/rename_fastq1/outfile"
                    ],
                    "run": "#rename.cwl",
                    "id": "#main/rename_fastq1"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/rename_fastq1/outfile",
                    "format": "https://edamontology.org/format_1931",
                    "id": "#main/fastq_file_1"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/fastq_dump/fastq_file_2",
                    "format": "https://edamontology.org/format_1931",
                    "id": "#main/fastq_file_2"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/fastq_dump/all_fastq_files",
                    "format": "https://edamontology.org/format_1931",
                    "id": "#main/fastq_files"
                }
            ],
            "id": "#main"
        },
        {
            "class": "ExpressionTool",
            "doc": "Also consider https://www.commonwl.org/user_guide/misc/#rename-an-input-file\nor https://www.commonwl.org/user_guide/misc/#rename-an-output-file\n",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#rename.cwl/newname"
                },
                {
                    "type": "File",
                    "id": "#rename.cwl/srcfile"
                }
            ],
            "expression": "${\n   inputs.srcfile.basename = inputs.newname;\n   return {\"outfile\": inputs.srcfile};\n }\n",
            "outputs": [
                {
                    "type": "File",
                    "id": "#rename.cwl/outfile"
                }
            ],
            "id": "#rename.cwl"
        }
    ],
    "cwlVersion": "v1.0",
    "$schemas": [
        "https://github.com/schemaorg/schemaorg/raw/main/data/releases/11.01/schemaorg-current-http.rdf",
        "https://edamontology.org/EDAM_1.18.owl"
    ],
    "$namespaces": {
        "edam": "https://edamontology.org/"
    }
}
